<?php
/**
 * @version		1.5.1
 * @package		Joomla
 * @subpackage	Edocman
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
/**
 * Edocman Component Import Model
 *
 * @package Joomla
 * @subpackage Edocman
 * @since 1.5
 */
class EdocmanModelImport extends JModelLegacy
{

	/**
	 * Store the configuration data
	 *
	 * @param array $post        	
	 */
	function store($data)
	{
		$db = JFactory::getDbo();
		jimport('joomla.filesystem.folder');
		$config = EdocmanHelper::getConfig();
		$row = JTable::getInstance('Document', 'EdocmanTable');
		$categoryId = (int) $data['category_id'];
		$data['folder'] = trim($data['folder']);
		$path = strlen($data['folder']) ? $config->documents_path . '/' . $data['folder'] : $config->documents_path;
		// Store category ID in $_POST array, use for permission setting
		$_POST['jform']['category_id'] = $categoryId;
		if ($data['exts'])
		{
			$fileExts = explode(',', $data['exts']);
			for ($i = 0, $n = count($fileExts); $i < $n; $i++)
			{
				$fileExts[$i] = trim($fileExts[$i]);
			}
			$filter = implode('|', $fileExts);
		}
		else
		{
			$filter = '.*';
		}
		
		$sql = 'SELECT `access` FROM #__edocman_categories WHERE id=' . $categoryId;
		$db->setQuery($sql);
		$categoryAccess = (int) $db->loadResult();
		$files = JFolder::files($path, $filter);
		if (count($files))
		{
			foreach ($files as $file)
			{
				$documentData = array();
				$documentData['access'] = $categoryAccess;
				$documentData['title'] = $documentData['original_filename'] = $file;
				$documentData['alias'] = '';
				$documentData['published'] = 1;
				if ($data['folder'])
				{
					$documentData['filename'] = $data['folder'] . '/' . $file;
				}
				else
				{
					$documentData['filename'] = $file;
				}
				// Check if the document is existed or not
				$sql = 'SELECT COUNT(id) FROM #__edocman_documents WHERE filename="' . $documentData['filename'] . '"';
				$db->setQuery($sql);
				$total = (int) $db->loadResult();
				if ($total > 0)
					continue;
				$documentData['id'] = 0;
				$row->bind($documentData);
				$row->check();
				$row->store();
			}
		}
		
		return true;
	}

	/**
	 * Import document from a specific folder and store them as EDocman
	 * documents
	 *
	 * @param JRegistry $params        	
	 */
	function importDocuments($params)
	{
		$db = JFactory::getDbo();
		$config = EdocmanHelper::getConfig();
		$documentsPath = $config->documents_path;
		$path = $params->get('documents_path', '');
		$path = str_replace('\\', '/', $path);
		$pathLength = strlen($path);
		if (!JFolder::exists($path))
			return;
		$folders = JFolder::folders($path);
		$sql = "SELECT id, `access`, `path` FROM #__edocman_categories WHERE `path` IN ('" . implode("','", $folders) . "')";
		$db->setQuery($sql);
		$categories = $db->loadObjectList('path');
		$row = JTable::getInstance('Document', 'EdocmanTable');
		$allowedFileTypes = $config->allowed_file_types;
		$allowedFileTypes = explode(',', $allowedFileTypes);
		$allowedFileTypes = array_map('trim', $allowedFileTypes);
		$allowedFileTypes = implode('|', $allowedFileTypes);
		$files = JFolder::files($path, $allowedFileTypes, true, true);
		if (count($files))
		{
			$sql = 'SELECT id, username FROM #__users WHERE block=0';
			$db->setQuery($sql);
			$users = $db->loadObjectList('username') ;
			$files = array_slice($files, 0, 30); // We will be import each
			foreach ($files as $file)
			{
				$originalFile = $file;
				$file = str_replace('\\', '/', $file);
				$file = substr($file, $pathLength + 1);
				$pos = strrpos($file, '/');
				$categoryPath = substr($file, 0, $pos);
				$category = $categories[$categoryPath];
				$_POST['jform']['category_id'] = $category->id;
				$fileName = JFile::getName($file);
				$documentData = array();
				$documentData['access'] = $category->access;
				$documentData['title'] = $documentData['original_filename'] = $fileName;
				$documentData['alias'] = '';
				$documentData['filename'] = $file;
				$documentData['published'] = 1;	
				$parts = explode('_', $fileName);
				if (count($parts) > 1) {
					$username = $parts[0] ;
					if (isset($users[$username])) {
						$documentData['user_ids'] = $users[$username]->id ;
					}
				}			
				// Check if the document is existed or not
				$sql = 'SELECT COUNT(id) FROM #__edocman_documents WHERE filename="' . $documentData['filename'] . '"';
				$db->setQuery($sql);
				$total = (int) $db->loadResult();
				if ($total > 0)
					continue;
				$documentData['id'] = 0;
				$row->bind($documentData);
				$row->check();
				$row->store();
				JFile::move($originalFile, $documentsPath . '/' . $file);
			}
		}
		
		return true;
	}
}